#ifndef __CXXTEST__DESCRIPTION_H
#define __CXXTEST__DESCRIPTION_H

//
// TestDescription, SuiteDescription and WorldDescription
// hold information about tests so they can be run and reported.
//

namespace CxxTest 
{
    class TestListener;
    class TestSuite;
    class TestRunner;

    class TestDescription
    {
    public:
	static const TestDescription _dummy;
	
        virtual const char *file() const { return "<no file>"; }
        virtual unsigned line() const { return 0; }
        virtual const char *testName() const { return "<no test>"; }
        virtual const char *suiteName() const { return "<no suite>"; }
        virtual void run() const {}
    };

    class SuiteDescription
    {
    public:
	static const SuiteDescription _dummy;
	
        virtual const char *file() const { return "<no file>"; }
        virtual unsigned line() const { return 0; }
        virtual const char *suiteName() const { return "<no suite>"; }
        virtual TestSuite *suite() const { return 0; }
        virtual unsigned numTests() const { return 0; }
        virtual const TestDescription &testDescription( unsigned i ) const { return TestDescription::_dummy; }
    };    

    class WorldDescription
    {
    public:
	static const WorldDescription _dummy;
	
	virtual unsigned numSuites( void ) const { return 0; }
	virtual unsigned numTotalTests( void ) const { return 0; }
        virtual const SuiteDescription &suiteDescription( unsigned i ) const { return SuiteDescription::_dummy; }
	
    protected:
	friend class TestRunner;
	virtual void setUp() const {}
	virtual void tearDown() const {}
    };
}

#endif // __CXXTEST__DESCRIPTION_H

