#ifndef __EXCEPTIONTEST_H
#define __EXCEPTIONTEST_H

#include <cxxtest/TestSuite.h>

//
// This test suite demonstrates the use of TS_ASSERT_THROWS
//

//
// If you're not using the generated test runner main(),
// you should add these lines:
//
#ifndef CXXTEST_HAVE_EH
#define CXXTEST_HAVE_EH
#endif

class ExceptionTest : public CxxTest::TestSuite
{
public:
    void testAssertion( void )
    {
        // This assert passes, since evilFunction throws an int
        TS_ASSERT_THROWS( evilFunction(3), int );
        // This assert passes, since evilFunction throws something
        TS_ASSERT_THROWS_ANYTHING( evilFunction(-30) );
        // This assert fails, since evilFunction doesn't throw char *
        TS_ASSERT_THROWS( evilFunction(5), const char * );
        // This assert fails since goodFunction throws nothing
        TS_ASSERT_THROWS_ANYTHING( goodFunction(1) );
        // The regular asserts will catch unhandled exceptions
        TS_ASSERT_EQUALS( evilFunction(3), 333 );
	// You can assert that a function throws nothing
        TS_ASSERT_THROWS_NOTHING( evilFunction(-1) );
        // If you want to catch the exceptions yourself, use the ETS_ marcos
        try {
            ETS_ASSERT_EQUALS( evilFunction(3), 333 );
        } catch(int i) {
            TS_FAIL( "evilFunction(3) failed" );
        }
    }

private:
    void goodFunction( int ) throw()
    {
    }
    
    int evilFunction( int i ) throw(int)
    {
        throw(i);
    }
};

#endif // __EXCEPTIONTEST_H
