#include <cxxtest/SelfTest.h>

//
// This sample shows how to use the CXXTEST_ macros to embed
// a test suite in the class being tested.
//

class MyComplex
{
    CXXTEST_SUITE(TestMyComplex)
    
public:
    CXXTEST_CODE({{
	MyComplex *c;
	
	void setUp() {
	    c = new MyComplex( 1.0, 2.0 );
	    TS_ASSERT(c);
	}

	void tearDown() {
	    delete c;
	}

	void testGetters() {
	    TS_ASSERT_DELTA( c->r(), 1.0, 0.0001 );
	    TS_ASSERT_DELTA( c->i(), 2.0, 0.0002 );
	}
    }})
    
    MyComplex( double r, double i )
    {
    }

    double r()
    {
        return 0;
    }

    double i()
    {
        return 0;
    }
};
