#include <cxxtest/TestRunner.h>
#include <stdio.h>

//
// This test runner printer some statistics at the end of the run.
// Note that it uses <stdio.h> and not <iostream> for compatibility
// with older compilers.
//

using namespace CxxTest;

class SummaryPrinter : public TestListener
{
public:
    void leaveWorld( const WorldDescription &wd )
    {
        printf( "Number of suites: %u\n", wd.numSuites() );
        printf( "Number of tests: %u\n", wd.numTotalTests() );
        printf( "Number of failed tests: %u\n", TestTracker::tracker().failedTests() );
    }
};

int main()
{
    SummaryPrinter sp;
    TestRunner::runAllTests( &sp );
    
    return 0;
}

//
// Local Variables:
// compile-command: "perl test.pl"
// End:
//
